//؂̕]l߂B
//g++ -I$LEDAROOT/incl -L$LEDAROOT -L/usr/X11R6/lib -o tree-evaluation-2 tree-evaluation-2.cpp -lW -lP -lG -lL -lX11 -lm

#include <iostream>
#include <fstream>
#include <LEDA/graphics/graphwin.h>
#include <LEDA/graph/graph.h>
#include <LEDA/graph/templates/shortest_path.h>
#include <LEDA/core/list.h>

#define SIZE 56
#define CHIMEI 50

using namespace leda;
using namespace std;              

int main()
{
  GRAPH<int,double> G;
  edge e;
  node v,u;
  int t_d[SIZE][SIZE],max_t_d=0,min_t_d =2,i,j,k=1;
  double sq,s_d[SIZE][SIZE],max_s_d=0,min_s_d=1,n_t_d[SIZE][SIZE],sum1=0,sum2=0,ave;
  char B[SIZE][CHIMEI];

  ifstream fin;
  fin.open("fileout");

  for(i=0;i<SIZE;i++)
    for(j=0;j<SIZE;j++){
      if(i==j)
	s_d[i][j]=0;
      else{
	fin>>B[0];
	fin>>s_d[i][j];
	if(s_d[i][j] < min_s_d)
	  min_s_d = s_d[i][j];
	else if(s_d[i][j] > max_s_d)
	  max_s_d = s_d[i][j];
      }
    }

  fin.close();
  
  // cout << "[1]" <<endl;
  
  G.read("quartet.gw");
  G.make_undirected();
  
  edge_array<int> cost(G);
  
  forall_edges(e,G)
    cost[e] = 1;
  
  node_array<int> dist(G,MAXINT);
  node_array<edge> pred(G);
  
  // cout << "[2]" <<endl;
  
  
  
  forall_nodes(v,G){
    DIJKSTRA_T(G,v,cost,dist,pred);
    if(index(v) < SIZE)
      forall_nodes(u,G){
      if(index(u) < SIZE){
	t_d[index(v)][index(u)]  = dist[u];
	if(dist[u] > max_t_d)
	  max_t_d = dist[u];
      }
    }
  }

  /*
    ---- tree distance ̋\\-------

  cout << "graph[1]" <<endl;
  
  forall_nodes(v,G){
    if(index(v) < SIZE){
      cout << index(v) << "|";
      DIJKSTRA_T(G,v,cost,dist,pred);
      forall_nodes(u,G){
	if(index(u) < SIZE)
	  if(index(v)==index(u))
	    printf("0  ");
	  else
	    printf("%d  ",dist1[u]);
      }
    }
    else
      break;
    putchar('\n');
  }
  putchar('\n');  
  */

  for(i=0;i<SIZE;i++){
    for(j=0;j<SIZE;j++){
      if(i==j)
	n_t_d[i][j]=0;
      else
	n_t_d[i][j]=min_s_d+((max_s_d-min_s_d)/(max_t_d-min_t_d)*(t_d[i][j]-2));
    }
  }



  for(i=0;i<SIZE;i++){
    // cout << i << " " <<sum1 << " " << sum2 << endl; 
    for(j=i+1;j<SIZE;j++){
      if(n_t_d[i][j] > s_d[i][j]){
	sum1 += n_t_d[i][j]-s_d[i][j];
	sum2 += (n_t_d[i][j]-s_d[i][j])*(n_t_d[i][j]-s_d[i][j]);
	//cout << j << " " <<sum1 << " " << sum2 << endl; 
      }
      else{
	sum1 += s_d[i][j]-n_t_d[i][j];
	sum2 += (s_d[i][j]-n_t_d[i][j])*(s_d[i][j]-n_t_d[i][j]);
	//cout << j << " " <<sum1 << " " << sum2 << endl; 
      }
    }
  }
  
  ave = sum1/(((SIZE*SIZE)/2)-SIZE);
  sq = sqrt(sum2);
  
  cout << "averege = " << ave << endl;
  cout << "square sum root = "<< sq << endl;
  
  /*  
      for(i=0;i<SIZE;i++){
      for(j=0;j<SIZE;j++){
      cout  << i <<"-" << j <<" " << "distance " << M1[i][j] <<" "<< M2[i][j]<< endl; 
      }
      }
  */
  
  
  
  return 0;
}

